﻿using System;
using System.Collections.Generic;
using IdeaBlade.Validation;

// ReSharper disable UseObjectOrCollectionInitializer

namespace Model
{
    public class ModelVerifierProvider : IVerifierProvider
    {
        public IEnumerable<Verifier> GetVerifiers(object verifierProviderContext)
        {
            var verifiers = new List<Verifier>
                {
                  new NotEmptyGuidVerifier(typeof(Customer), Customer.PropertyMetadata.CustomerID.Name),

                  new NotEmptyGuidVerifier(typeof(Order), Order.PropertyMetadata.CustomerID.Name),
                };

            return verifiers;
        }

    }
}