﻿using System;
using IdeaBlade.Validation;
// ReSharper disable RedundantThisQualifier
namespace Model
{
    /// <summary>
    /// Ensure that the Guid property value is not the empty Guid
    /// </summary>
    public class NotEmptyGuidVerifier : PropertyValueVerifier
    {

        public NotEmptyGuidVerifier(
            Type entityType, String propertyName,
            String displayName = null, bool? treatEmptyStringAsNull = null)
            : base(new PropertyValueVerifierArgs(
                entityType, propertyName, false,
                displayName, treatEmptyStringAsNull))
        {}

        protected override void OnVerifierEngineAttach()
        {
            this.ErrorMessageInfo.ErrorMessage =  // Message to display when invalid
                String.Format("{0} cannot be empty", this.DisplayName);
        }

        protected override VerifierResult VerifyValue(
            object itemToVerify, object valueToVerify,
            TriggerContext triggerContext, VerifierContext verifierContext)
        {
            return new VerifierResult(
                !Equals(valueToVerify,Guid.Empty));
        }
    }

}
