﻿using System.ComponentModel.DataAnnotations;
using IdeaBlade.Validation;

// ReSharper disable RedundantNameQualifier

namespace Model
{
    // The MetadataTypeAttribute identifies OrderDetailMetadata as the class
    // that carries additional metadata for the OrderDetail class.
    [MetadataType(typeof(OrderDetail.OrderDetailMetadata))]
    public partial class OrderDetail
    {
        // This class allows you to attach custom attributes to properties
        // of the Book class.

        internal sealed class OrderDetailMetadata
        {
            // Metadata classes are not meant to be instantiated.
            private OrderDetailMetadata() { }

            [Unique]
            [Int32RangeVerifier(MinValue = 0) ]
            public int Quantity { get; set; }

        }
    }
}
