﻿using System.Linq;
using IdeaBlade.EntityModel;
using SoftwareApproach.TestingExtensions;
using Model;
using Microsoft.VisualStudio.TestTools.UnitTesting;

// ReSharper disable InconsistentNaming
// ReSharper disable LocalizableElement

// TESTS FOR .NET ONLY - WON'T WORK IN SILVERLIGHT
// See Model.UniqueVerifier
namespace ValidationLab
{

    [TestClass]
    public class When_OrderDetail_quantity_must_be_unique
    {
        // A Unique attribute was added to OrderDetail.Quantity in OrderDetail.cs

        // Testing OrderDetail because it has a multi-part key and want to ensure that
        // IsDuplicateQueryBuilder handles multi-part keys properly

        [TestInitialize]
        public void TestInitialize()
        {
            Manager = new NorthwindIBEntities();
        }

        /// <summary>
        /// '10' is a common quantity value for OrderDetails
        /// "Unique quantity" validation should prevent
        /// setting an OrderDetails' quantity to '10'
        /// </summary>
        [TestMethod]
        public void OrderDetail_cannot_set_quantity_10()
        {
            var orderDetailWithQty12 =
                Manager.OrderDetails.Where(od => od.Quantity == 12).First();

            orderDetailWithQty12.Quantity = 10; // Known to occur frequently in db

            orderDetailWithQty12.EntityAspect.ValidationErrors.Any().ShouldBeTrue(
                "Expected validation error when set quantity of orderDetailWithQty12 to 10."
                );

            
           orderDetailWithQty12.Quantity.ShouldEqual((short)12,
                "orderDetailWithQty12 quantity should be unchanged");
        }

        private NorthwindIBEntities Manager { get; set; }

    }

}